<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/DccCommander.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('DccCommander_8hpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">DccCommander.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __dccCommander_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __dccCommander_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_DCCCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;DCC_Decoder.hpp&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#define DccCommander DccCommanderClass::GetCurrent()</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">typedef</span> void(*DccAccDecoderPacket)(<span class="keywordtype">int</span> address, <span class="keywordtype">boolean</span> activate, uint8_t data);</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// A dcc id is a long int with accessory id * 10000 + dcc id .</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#define DCCID(id)           ((id) % 10000)</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#define DCCACTIVATION(id)   ((uint8_t)((id) / 10000))</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define DCCINT(id, acc)     ((acc) * 10000UL + (id))</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classDccCommanderClass.html">   73</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDccCommanderClass.html">DccCommanderClass</a> : <a class="code" href="classCommander.html">Commander</a></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;{</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> LastDccId;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordtype">boolean</span> UseRawDccAddresses;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">static</span> DccAccDecoderPacket    func_AccPacket;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keyword">static</span> <a class="code" href="classDccCommanderClass.html">DccCommanderClass</a> *pDccCommander;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keyword">public</span>:                                 </div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="classDccCommanderClass.html#ac10ea64d33e686c877bdcb3024068e02">   83</a></span>&#160;        <span class="keyword">inline</span> <a class="code" href="classDccCommanderClass.html#ac10ea64d33e686c877bdcb3024068e02">DccCommanderClass</a>() : <a class="code" href="classCommander.html">Commander</a>() {}</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        </div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a6ec17894419857a33c2667e925da456e">begin</a>(<span class="keywordtype">int</span> i, <span class="keywordtype">int</span> j, <span class="keywordtype">int</span> k, <span class="keywordtype">boolean</span> inInterruptMonitor = <span class="keyword">false</span>, <span class="keywordtype">boolean</span> inUseRawDccAddresses = <span class="keyword">false</span>);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a688f192c9f26dfe824a86b6aa00152df">PriorityLoop</a>();</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classDccCommanderClass.html#a0c97ea34dfdf4c13de53a58937df5580">loop</a>();</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a676e59c4b5cc8c604221e0b6e32d8aca">SetAccessoryDecoderPacketHandler</a>(DccAccDecoderPacket func);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a513e3e0cabaad7cf7ebbfa4bd767c368">DccAccessoryDecoderPacket</a>(<span class="keywordtype">int</span> address, <span class="keywordtype">boolean</span> activate, uint8_t data);</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classDccCommanderClass.html#a97a3afabe3aca9b97728b3d8679ad66b">  109</a></span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classDccCommanderClass.html#a97a3afabe3aca9b97728b3d8679ad66b">GetLastDccId</a>() { <span class="keywordflow">return</span> this-&gt;LastDccId; }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classDccCommanderClass.html#a71585f785e9676ae03477557949ecd9a">  115</a></span>&#160;        <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="classDccCommanderClass.html">DccCommanderClass</a> &amp;<a class="code" href="classDccCommanderClass.html#a71585f785e9676ae03477557949ecd9a">GetCurrent</a>() </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        { </div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            <span class="keywordflow">if</span> (pDccCommander == NULL)</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                pDccCommander = <span class="keyword">new</span> <a class="code" href="classDccCommanderClass.html#ac10ea64d33e686c877bdcb3024068e02">DccCommanderClass</a>();</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="keywordflow">return</span> *(DccCommanderClass::pDccCommander); </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a65088d66788156ea4a41027af1528298">printEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEventType, <span class="keywordtype">int</span> inEventData);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="preprocessor">    #define PRINT_EVENT_DCC(id, type, data)     DccCommander::printEvent(id, type, data);</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="preprocessor">    #define PRINT_EVENT_DCC(id, type, data)</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    int8_t Interrupt;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDccCommanderClass.html#a9eb04a79497f70417cbb690e9dc3614c">printCommander</a>();</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;};</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="ttc" id="classDccCommanderClass_html_a9eb04a79497f70417cbb690e9dc3614c"><div class="ttname"><a href="classDccCommanderClass.html#a9eb04a79497f70417cbb690e9dc3614c">DccCommanderClass::printCommander</a></div><div class="ttdeci">void printCommander()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00230">DccCommander.cpp:230</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a65088d66788156ea4a41027af1528298"><div class="ttname"><a href="classDccCommanderClass.html#a65088d66788156ea4a41027af1528298">DccCommanderClass::printEvent</a></div><div class="ttdeci">static void printEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEventType, int inEventData)</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00179">DccCommander.cpp:179</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a71585f785e9676ae03477557949ecd9a"><div class="ttname"><a href="classDccCommanderClass.html#a71585f785e9676ae03477557949ecd9a">DccCommanderClass::GetCurrent</a></div><div class="ttdeci">static DccCommanderClass &amp; GetCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8hpp_source.html#l00115">DccCommander.hpp:115</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a97a3afabe3aca9b97728b3d8679ad66b"><div class="ttname"><a href="classDccCommanderClass.html#a97a3afabe3aca9b97728b3d8679ad66b">DccCommanderClass::GetLastDccId</a></div><div class="ttdeci">unsigned long GetLastDccId()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8hpp_source.html#l00109">DccCommander.hpp:109</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a513e3e0cabaad7cf7ebbfa4bd767c368"><div class="ttname"><a href="classDccCommanderClass.html#a513e3e0cabaad7cf7ebbfa4bd767c368">DccCommanderClass::DccAccessoryDecoderPacket</a></div><div class="ttdeci">static void DccAccessoryDecoderPacket(int address, boolean activate, uint8_t data)</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00023">DccCommander.cpp:23</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a676e59c4b5cc8c604221e0b6e32d8aca"><div class="ttname"><a href="classDccCommanderClass.html#a676e59c4b5cc8c604221e0b6e32d8aca">DccCommanderClass::SetAccessoryDecoderPacketHandler</a></div><div class="ttdeci">static void SetAccessoryDecoderPacketHandler(DccAccDecoderPacket func)</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00173">DccCommander.cpp:173</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a0c97ea34dfdf4c13de53a58937df5580"><div class="ttname"><a href="classDccCommanderClass.html#a0c97ea34dfdf4c13de53a58937df5580">DccCommanderClass::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00134">DccCommander.cpp:134</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a688f192c9f26dfe824a86b6aa00152df"><div class="ttname"><a href="classDccCommanderClass.html#a688f192c9f26dfe824a86b6aa00152df">DccCommanderClass::PriorityLoop</a></div><div class="ttdeci">void PriorityLoop()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00118">DccCommander.cpp:118</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_a6ec17894419857a33c2667e925da456e"><div class="ttname"><a href="classDccCommanderClass.html#a6ec17894419857a33c2667e925da456e">DccCommanderClass::begin</a></div><div class="ttdeci">void begin(int i, int j, int k, boolean inInterruptMonitor = false, boolean inUseRawDccAddresses = false)</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8cpp_source.html#l00097">DccCommander.cpp:97</a></div></div>
<div class="ttc" id="classDccCommanderClass_html_ac10ea64d33e686c877bdcb3024068e02"><div class="ttname"><a href="classDccCommanderClass.html#ac10ea64d33e686c877bdcb3024068e02">DccCommanderClass::DccCommanderClass</a></div><div class="ttdeci">DccCommanderClass()</div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8hpp_source.html#l00083">DccCommander.hpp:83</a></div></div>
<div class="ttc" id="classCommander_html"><div class="ttname"><a href="classCommander.html">Commander</a></div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00023">Commander.hpp:23</a></div></div>
<div class="ttc" id="classDccCommanderClass_html"><div class="ttname"><a href="classDccCommanderClass.html">DccCommanderClass</a></div><div class="ttdef"><b>Definition:</b> <a href="DccCommander_8hpp_source.html#l00073">DccCommander.hpp:73</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>DccCommander.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
